#ifndef __HAVE_PATCH_H__
#define __HAVE_PATCH_H__

#define PATCHOPTIONS 17

#define OPER_CANSET_K		1
#define OPER_CANSET_X		2
#define OPER_CANJOIN_I		3
#define OPER_CANJOIN_K		4
#define OPER_CANJOIN_B		5
#define OPER_CANJOIN_L		6
#define X_CANKILL_K             7
#define X_CANDEOP_K             8
#define X_CANKICK_K             9
#define USE_FAKEHOST		10
#define OPER_CANSEND_N		11
#define OPER_CANSEND_M		12
#define OPER_SERVMODE		13
#define OPER_DYNHOST		14
#define USER_SETHOST		15
#define OPER_CANFLOOD           16
#define OPER_NOLAG              17

#define DESC_OPER_CANSET_K	" Opers can set umode +k (Channel Service)"
#define DESC_OPER_CANSET_X	"   Opers can set umode +X (Extended oper)"
#define DESC_OPER_CANJOIN_I	"           ..to join invite only channels"
#define DESC_OPER_CANJOIN_K	"                 ..to join keyed channels"
#define DESC_OPER_CANJOIN_B	"             ..to join channels if banned"
#define DESC_OPER_CANJOIN_L	"                  ..to join full channels"
#define DESC_X_CANKICK_K        "                     ..to kick +k clients"
#define DESC_X_CANDEOP_K        "                     ..to deop +k clients"
#define DESC_X_CANKILL_K        "                     ..to kill +k clients"
#define DESC_USE_FAKEHOST	"              Enable fakehosts (F: lines)"
#define DESC_OPER_CANSEND_N     " Opers can message +n channels externally"
#define DESC_OPER_CANSEND_M     "    Opers can speak on moderated channels"
#define DESC_OPER_SERVMODE	"           Opers can use servmode command"
#define DESC_OPER_DYNHOST	"  Opers can change their host dynamically"
#define DESC_USER_SETHOST	"Allow users to SETHOST passworded S:lines"
#define DESC_OPER_CANFLOOD      "        Opers will not exceed their SendQ"
#define DESC_OPER_NOLAG         " Opers have smaller penalty when flooding"

#define HEADERLINE "--------------------------------------------------------------------"
#define DGPHFILE                "demogrph_countries.txt"

extern int IsOption(int option);
extern int LogOption(int option);
extern void LogFeature(struct Client *cptr, int type, const char *fmt, ...);
extern void show_patchinfo(struct Client *cptr);
extern int IsService(struct Client *cptr);
extern int m_check(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_sethost(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_servmode(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern int m_patchinfo(struct Client *cptr, struct Client *sptr, int parc, char *parv[]);
extern char *ConstructMask(char *hoststr);
extern char *PadChar(int length, int max, char ch);
extern char *GetVhostPass(char *hostmsk);

#endif // __HAVE_PATCH_H__
